use BBB ;

DROP FUNCTION IF EXISTS PROPERSPACE;

-- set upper case the first char of every word in a string
DELIMITER //
CREATE or replace FUNCTION PROPERSPACE(inputStr varchar(200))
RETURNS VARCHAR(200)
DETERMINISTIC
BEGIN
    DECLARE x, y, result VARCHAR(200);
    SET result = '';
    SET x = '';
    SET y = LOWER(TRIM(inputStr));
    WHILE CHAR_LENGTH(y) > 0 DO
        -- get next word
        SET x = SUBSTRING_INDEX(y, ' ', 1);
        -- set upper case the first char
        SET x = CONCAT(UPPER(SUBSTRING(x, 1, 1)), SUBSTRING(x, 2));
        -- add word to result
        SET result = CONCAT(result, ' ', x);
        -- prepare y for next loop
        SET y = TRIM(SUBSTRING(y, CHAR_LENGTH(x) + 1));
    END WHILE;
    RETURN (TRIM(result));
END //
DELIMITER ;
